/*

IFT1169 - Surcharge des oprateurs - Exemple 04 -

09-fvrier		- 2015 v1.00	M.Lokbani - GCC 4.9.2  avec -std=c++11


contact: lokbani@iro.umontreal.ca

        
    Copyright (C) 1999-2015 Universit de Montral
            Dpartement d'informatique et de Recherche Oprationnelle
            Mohamed Lokbani
    -- Tous Droits Rservs -- All Rights Reserved --

Description:
------------
    La surcharge des oprateurs.
    Dans cet exemple nous allons dfinir un Rvalue par rfrence.
    
    Voir notes de cours, 9.2: Les rfrences dans le cas de "RValue"
    
*/


#include <iostream>

using namespace std;

int test() {
	
	int x = 50;
		
	return x;
}

int main(){

	
	// La fonction test retourne une valeur, c'est une "Rvalue".
	// Si on veut capturer cette valeur dans un nouveau espace,
	// on utilise une rfrence sur une "Rvalue"
	
	int&& z = test();

	cout << "z: " << z << endl;

	// Erreur:
	// error: invalid initialization of non-const reference of type 'int&' from an rvalue of type 'int'
	// On ne peut pas initialiser une rfrence "lvalue" avec une "Rvalue".

//	int& w = test();


	
	return 0;
}